diff --git a/gdb/doc/gdb.texinfo b/gdb/doc/gdb.texinfo
index 4ada257d256..99056e210d5 100644
--- a/gdb/doc/gdb.texinfo
+++ b/gdb/doc/gdb.texinfo
@@ -2725,7 +2725,7 @@ automatically with the @code{set auto-connect-native-target off}
 command.
 
 If @code{on}, which is the default, and if the current inferior is not
-connected to a target already, the @code{run} command automaticaly
+connected to a target already, the @code{run} command automatically
 connects to the native target, if one is available.
 
 If @code{off}, and if the current inferior is not connected to a
@@ -14511,7 +14511,7 @@ There is no execution history stored (possible @ref{Reverse Execution} is never
 used for this purpose) and the last known caller could have reached the known
 callee by multiple different jump sequences.  In such case @value{GDBN} still
 tries to show at least all the unambiguous top tail callers and all the
-unambiguous bottom tail calees, if any.
+unambiguous bottom tail callees, if any.
 
 @table @code
 @anchor{set debug entry-values}
@@ -21429,7 +21429,7 @@ will print to the console.
 which may not be obvious for remote targets of different architecture
 than where @value{GDBN} is running.  Environment variable @env{PATH} on
 @value{GDBN} host is searched for @value{NGCC} binary matching the
-target architecture and operating system.  This search can be overriden
+target architecture and operating system.  This search can be overridden
 by @code{set compile-gcc} @value{GDBN} command below.  @env{PATH} is
 taken from shell that executed @value{GDBN}, it is not the value set by
 @value{GDBN} command @code{set environment}).  @xref{Environment}.
@@ -25117,7 +25117,7 @@ attributes of that page.
 Note that you must cast the addresses of variables to a @code{char *},
 since otherwise the value of @code{__djgpp_base_address}, the base
 address of all variables and functions in a @sc{djgpp} program, will
-be added using the rules of C pointer arithmetics: if @code{i} is
+be added using the rules of C pointer arithmetic: if @code{i} is
 declared an @code{int}, @value{GDBN} will add 4 times the value of
 @code{__djgpp_base_address} to the address of @code{i}.
 
@@ -28252,7 +28252,7 @@ by the host platform path separator in use.
 This variable defaults to what @code{--with-auto-load-dir} has been configured
 to (@pxref{with-auto-load-dir}).  @file{$debugdir} and @file{$datadir}
 substitution applies the same as for @ref{set auto-load scripts-directory}.
-The default @code{set auto-load safe-path} value can be also overriden by
+The default @code{set auto-load safe-path} value can be also overridden by
 @value{GDBN} configuration option @option{--with-auto-load-safe-path}.
 
 Setting this variable to @file{/} disables this security protection,
@@ -29902,7 +29902,7 @@ Each entry here needs to be covered also by the security setting
 
 @anchor{with-auto-load-dir}
 This variable defaults to @file{$debugdir:$datadir/auto-load}.  The default
-@code{set auto-load safe-path} value can be also overriden by @value{GDBN}
+@code{set auto-load safe-path} value can be also overridden by @value{GDBN}
 configuration option @option{--with-auto-load-dir}.
 
 Any reference to @file{$debugdir} will get replaced by
@@ -32078,7 +32078,7 @@ value is @samp{y}, or disabled, in which case the value is @samp{n}.
 Note that this is not the same as the field @code{enable}.
 
 @item addr
-The address of the breakpoint.  This may be a hexidecimal number,
+The address of the breakpoint.  This may be a hexadecimal number,
 giving the address; or the string @samp{<PENDING>}, for a pending
 breakpoint; or the string @samp{<MULTIPLE>}, for a breakpoint with
 multiple locations.  This field will not be present if no address can
@@ -32198,7 +32198,7 @@ at this location.
 @end table
 
 @item addr
-The address of this location as an hexidecimal number.
+The address of this location as an hexadecimal number.
 
 @item addr_flags
 Optional field containing any flags related to the address.  These flags are
@@ -35193,7 +35193,7 @@ The syntax for the @var{format-spec} is as follows:
  @{binary | decimal | hexadecimal | octal | natural | zero-hexadecimal@}
 @end smallexample
 
-The natural format is the default format choosen automatically
+The natural format is the default format chosen automatically
 based on the variable type (like decimal for an @code{int}, hex
 for pointers, etc.).
 
@@ -36378,7 +36378,7 @@ literal.
 The offset relative to @var{address} at which to start reading.  This
 should be an integer literal.  This option is provided so that a frontend
 is not required to first evaluate address and then perform address
-arithmetics itself.
+arithmetic itself.
 
 @end table
 
@@ -36808,12 +36808,12 @@ the following fields:
 May have a value of either @samp{0}, when no tracing operations are
 supported, @samp{1}, when all tracing operations are supported, or
 @samp{file} when examining trace file.  In the latter case, examining
-of trace frame is possible but new tracing experiement cannot be
+of trace frame is possible but new tracing experiment cannot be
 started.  This field is always present.
 
 @item running
 May have a value of either @samp{0} or @samp{1} depending on whether
-tracing experiement is in progress on target.  This field is present
+tracing experiment is in progress on target.  This field is present
 if @samp{supported} field is not @samp{0}.
 
 @item stop-reason
@@ -37085,8 +37085,8 @@ The corresponding @value{GDBN} command is @samp{info module functions}.
              symbols=[@{line="30",name="mod2::check_var_i",type="void (void)",
                        description="void mod2::check_var_i(void);"@}]@}]@},
     @{module="mod3",
-     files=[@{filename="/projec/gdb/testsuite/gdb.mi/mi-fortran-modules.f90",
-             fullname="/projec/gdb/testsuite/gdb.mi/mi-fortran-modules.f90",
+     files=[@{filename="/project/gdb/testsuite/gdb.mi/mi-fortran-modules.f90",
+             fullname="/project/gdb/testsuite/gdb.mi/mi-fortran-modules.f90",
              symbols=[@{line="21",name="mod3::check_all",type="void (void)",
                        description="void mod3::check_all(void);"@},
                       @{line="27",name="mod3::check_mod2",type="void (void)",
@@ -40542,13 +40542,13 @@ them if your system doesn't already include them.
 @table @asis
 @item GMP (The GNU Multiple Precision arithmetic library)
 @value{GDBN} uses GMP to perform some of its extended-precision
-arithmetics.  The latest version of GMP is available from
+arithmetic.  The latest version of GMP is available from
 @url{https://gmplib.org/}.
 
 @anchor{MPFR}
 @item MPFR (The GNU Multiple-precision floating-point library)
 @value{GDBN} uses MPFR to emulate the target floating-point
-arithmetics during expression evaluation, if the target uses different
+arithmetic during expression evaluation, if the target uses different
 floating-point formats than the host.  The latest version of MPFR is
 available from @url{http://www.mpfr.org}.
 @end table
@@ -41768,7 +41768,7 @@ data structures, including its flags and contained types.
 @itemx maint print record-instruction @var{N}
 print how GDB recorded a given instruction.  If @var{n} is not positive
 number, it prints the values stored by the inferior before the @var{n}-th previous
-instruction was exectued.  If @var{n} is positive, print the values after the @var{n}-th
+instruction was executed.  If @var{n} is positive, print the values after the @var{n}-th
 following instruction is executed.  If @var{n} is not given, 0 is assumed.
 
 @kindex maint selftest
@@ -46731,7 +46731,7 @@ If the @samp{Ctrl-C} flag is set in the @value{GDBN}
 reply packet (@pxref{The F Reply Packet}),
 the target should behave as if it had
 gotten a break message.  The meaning for the target is ``system call
-interrupted by @code{SIGINT}''.  Consequentially, the target should actually stop
+interrupted by @code{SIGINT}''.  Consequently, the target should actually stop
 (as with a break message) and return to @value{GDBN} with a @code{T02}
 packet.
 
@@ -50096,7 +50096,7 @@ These values are reserved.
 This bit is zero if the value is global and one if it is static.
 
 The determination of whether a symbol is global or static is complicated.
-The authorative reference is the file @file{dwarf2read.c} in
+The authoritative reference is the file @file{dwarf2read.c} in
 @value{GDBN} sources.
 
 @end table
diff --git a/gdb/doc/guile.texi b/gdb/doc/guile.texi
index aae0c6a5cc9..eeab870b660 100644
--- a/gdb/doc/guile.texi
+++ b/gdb/doc/guile.texi
@@ -1478,7 +1478,7 @@ pretty-printer.  Guile scalars (integers, floats, and booleans) and
 strings are convertible to @code{<gdb:value>}; other types are not.
 
 Finally, if this method returns @code{#f} then no further operations
-are peformed in this method and nothing is printed.
+are performed in this method and nothing is printed.
 
 If the result is not one of these types, an exception is raised.
 
@@ -3882,7 +3882,7 @@ or @code{#f} in which case @var{printer} is added to the global list of
 printers.
 @end deffn
 
-@deffn {Scheme Procecure} append-pretty-printer! object printer
+@deffn {Scheme Procedure} append-pretty-printer! object printer
 Add @var{printer} to the end of the list of pretty-printers for
 @var{object}.  The @var{object} must either be a @code{<gdb:objfile>} object,
 or @code{#f} in which case @var{printer} is added to the global list of
diff --git a/gdb/doc/python.texi b/gdb/doc/python.texi
index d74defeec0c..a92f39ea45d 100644
--- a/gdb/doc/python.texi
+++ b/gdb/doc/python.texi
@@ -1852,7 +1852,7 @@ pretty-printer.  Python scalars (integers, floats, and booleans) and
 strings are convertible to @code{gdb.Value}; other types are not.
 
 Finally, if this method returns @code{None} then no further operations
-are peformed in this method and nothing is printed.
+are performed in this method and nothing is printed.
 
 If the result is not one of these types, an exception is raised.
 @end defun
@@ -2836,7 +2836,7 @@ unwinder has three methods.  The first one checks if it can handle
 given frame (``sniff'' it).  For the frames it can sniff an unwinder
 provides two additional methods: it can return frame's ID, and it can
 fetch registers from the previous frame.  A running @value{GDBN}
-mantains a list of the unwinders and calls each unwinder's sniffer in
+maintains a list of the unwinders and calls each unwinder's sniffer in
 turn until it finds the one that recognizes the current frame.  There
 is an API to register an unwinder.
 